{
  "x-generator": "On Key REST API Docs Generator",
  "openapi": "3.0.0",
  "info": {
    "title": "On Key AOM  API Specification",
    "description": "Better and smarter enterprise asset management with one of the world's leading Enterprise Asset Management (EAM) systems.",
    "termsOfService": "https://www.onkey.com/",
    "contact": {
      "name": "On Key Support",
      "url": "https://www.onkey.com/",
      "email": "onkey.support@pragmaworld.net"
    },
    "license": {
      "name": "On Key Licence",
      "url": "https://www.onkey.com/"
    },
    "version": "1.0.0"
  },
  "servers": [
    {
      "url": "{scheme}://{server}:{port}/api/tenants/{client}/{connection}",
      "description": "On Key API Server",
      "variables": {
        "scheme": {
          "default": "https",
          "description": "HTTP scheme"
        },
        "server": {
          "default": "<variable>",
          "description": "Server host"
        },
        "port": {
          "default": "443",
          "description": "Port"
        },
        "client": {
          "default": "<variable>",
          "description": "Client"
        },
        "connection": {
          "default": "<variable>",
          "description": "Connection/Environment (i.e. prod, qa)"
        }
      }
    }
  ],
  "paths": {
    "/Modules/AOM/Consumables/{id}": {
      "get": {
        "tags": [
          "Consumable"
        ],
        "summary": "Get a Consumable resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Consumable->Code | string |  |\r\n| isActive | Consumable->IsActive | boolean |  |\r\n| createdByUserId | Consumable->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | Consumable->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | Consumable->CreatedByUser_FullName | string |  |\r\n| createdOn | Consumable->CreatedOn | string | date-time |\r\n| modifiedByUserId | Consumable->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | Consumable->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | Consumable->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | Consumable->ModifiedOn | string | date-time |\r\n| version | Consumable->Version | integer | int32 |\r\n| permissionTreeId | Consumable->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | Consumable->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | Consumable->PermissionTree_Description | string |  |\r\n| siteId | Consumable->Site_Id | integer | int64 |\r\n| siteCode | Consumable->Site_Code | string |  |\r\n| siteDescription | Consumable->Site_Description | string |  |\r\n| id | Consumable->Id | integer | int64 |\r\n| currencyId | Consumable->Currency_Id | integer | int64 |\r\n| currencyCode | Consumable->Currency_Code | string |  |\r\n| currencyDescription | Consumable->Currency_Description | string |  |\r\n| description | Consumable->Description | string |  |\r\n| notes | Consumable->Notes | string |  |\r\n| unitOfMeasurementId | Consumable->UnitOfMeasurement_Id | integer | int64 |\r\n| unitOfMeasurementCode | Consumable->UnitOfMeasurement_Code | string |  |\r\n| unitOfMeasurementDescription | Consumable->UnitOfMeasurement_Description | string |  |\r\n| unitPrice | Consumable->UnitPrice | number | decimal |\r\n",
        "operationId": "GetConsumable",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Consumable Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains Consumable",
            "content": {
              "application/vnd.onkey.entity+json": {
                "schema": {
                  "$ref": "#/components/schemas/GetConsumableResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "patch": {
        "tags": [
          "Consumable"
        ],
        "summary": "Update an existing Consumable resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Consumable->Version | integer | int32 |\r\n| code | Consumable->Code | string |  |\r\n| currencyId | Consumable->Currency_Id | integer | int64 |\r\n| description | Consumable->Description | string |  |\r\n| notes | Consumable->Notes | string |  |\r\n| siteId | Consumable->Site_Id | integer | int64 |\r\n| unitOfMeasurementId | Consumable->UnitOfMeasurement_Id | integer | int64 |\r\n| unitPrice | Consumable->UnitPrice | number | decimal |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| unitPrice | Min Value | >= 0|  |\r\n\r\n",
        "operationId": "UpdateConsumable",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Consumable Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patch",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatch+json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateConsumableResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - Consumable was successfully updated"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "delete": {
        "tags": [
          "Consumable"
        ],
        "summary": "Delete an existing Consumable resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Consumable->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "DeleteConsumable",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Consumable Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "delete",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitydelete+json": {
              "schema": {
                "$ref": "#/components/schemas/DeleteConsumableResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - Consumable was successfully deleted"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Consumables": {
      "get": {
        "tags": [
          "Consumable"
        ],
        "summary": "Get a collection of Consumable resources.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Consumable->Version | integer | int32 |\r\n| id | Consumable->Id | integer | int64 |\r\n| code | Consumable->Code | string |  |\r\n| currencyId | Consumable->Currency_Id | integer | int64 |\r\n| currencyCode | Consumable->Currency_Code | string |  |\r\n| currencyDescription | Consumable->Currency_Description | string |  |\r\n| description | Consumable->Description | string |  |\r\n| isActive | Consumable->IsActive | boolean |  |\r\n| siteId | Consumable->Site_Id | integer | int64 |\r\n| siteCode | Consumable->Site_Code | string |  |\r\n| siteDescription | Consumable->Site_Description | string |  |\r\n| unitPrice | Consumable->UnitPrice | number | decimal |\r\n| unitOfMeasurementId | Consumable->UnitOfMeasurement_Id | integer | int64 |\r\n| unitOfMeasurementCode | Consumable->UnitOfMeasurement_Code | string |  |\r\n| unitOfMeasurementDescription | Consumable->UnitOfMeasurement_Description | string |  |\r\n| notes | Consumable->Notes | string |  |\r\n| createdOn | Consumable->CreatedOn | string | date-time |\r\n| modifiedOn | Consumable->ModifiedOn | string | date-time |\r\n",
        "operationId": "GetConsumableCollection",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable Consumable collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/GetConsumableCollectionResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "post": {
        "tags": [
          "Consumable"
        ],
        "summary": "Create a new Consumable resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Consumable->Code | string |  |\r\n| currencyId | Consumable->Currency_Id | integer | int64 |\r\n| description | Consumable->Description | string |  |\r\n| notes | Consumable->Notes | string |  |\r\n| permissionTreeId | Consumable->PermissionTree_Id | integer | int64 |\r\n| siteId | Consumable->Site_Id | integer | int64 |\r\n| unitOfMeasurementId | Consumable->UnitOfMeasurement_Id | integer | int64 |\r\n| unitPrice | Consumable->UnitPrice | number | decimal |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n| unitPrice | Min Value | >= 0|  |\r\n\r\n",
        "operationId": "CreateConsumable",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "post",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entity+json": {
              "schema": {
                "$ref": "#/components/schemas/CreateConsumableResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "201": {
            "$ref": "#/components/responses/created",
            "description": ""
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Lookups/LookupConsumableChangePermissionTree": {
      "get": {
        "tags": [
          "Consumable"
        ],
        "summary": "Lookup the permission set for changing the Consumable.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupConsumableChangePermissionTree",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable  collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/ConsumableChangePermissionTreeLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Lookups/LookupConsumableCurrency": {
      "get": {
        "tags": [
          "Consumable"
        ],
        "summary": "Lookup Currency for the Consumable",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Currency->Id | integer | int64 |\r\n| code | Currency->Code | string |  |\r\n| description | Currency->Description | string |  |\r\n",
        "operationId": "LookupConsumableCurrency",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable Currency collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/ConsumableCurrencyLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Lookups/LookupConsumableInsertPermissionTree": {
      "get": {
        "tags": [
          "Consumable"
        ],
        "summary": "Lookup the permission set for creating the Consumable.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupConsumableInsertPermissionTree",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable  collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/ConsumableInsertPermissionTreeLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Lookups/LookupConsumableSite": {
      "get": {
        "tags": [
          "Consumable"
        ],
        "summary": "Lookup the Site for the Consumable.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Site->Id | integer | int64 |\r\n| code | Site->Code | string |  |\r\n| description | Site->Description | string |  |\r\n| currencyId | Site->Currency_Id | integer | int64 |\r\n| currencyCode | Site->Currency_Code | string |  |\r\n| currencyDescription | Site->Currency_Description | string |  |\r\n",
        "operationId": "LookupConsumableSite",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable Site collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/ConsumableSiteLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Lookups/LookupConsumableUnitOfMeasurement": {
      "get": {
        "tags": [
          "Consumable"
        ],
        "summary": "Lookup the Unit Of Measurement for the Consumable.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | UnitOfMeasurement->Id | integer | int64 |\r\n| code | UnitOfMeasurement->Code | string |  |\r\n| description | UnitOfMeasurement->Description | string |  |\r\n",
        "operationId": "LookupConsumableUnitOfMeasurement",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable Unit Of Measurement collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/ConsumableUnitOfMeasurementLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Batch/{ids}": {
      "get": {
        "tags": [
          "Consumable"
        ],
        "summary": "Get a collection of Consumable resources for the set of id's.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Consumable->Code | string |  |\r\n| isActive | Consumable->IsActive | boolean |  |\r\n| createdByUserId | Consumable->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | Consumable->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | Consumable->CreatedByUser_FullName | string |  |\r\n| createdOn | Consumable->CreatedOn | string | date-time |\r\n| modifiedByUserId | Consumable->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | Consumable->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | Consumable->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | Consumable->ModifiedOn | string | date-time |\r\n| version | Consumable->Version | integer | int32 |\r\n| permissionTreeId | Consumable->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | Consumable->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | Consumable->PermissionTree_Description | string |  |\r\n| siteId | Consumable->Site_Id | integer | int64 |\r\n| siteCode | Consumable->Site_Code | string |  |\r\n| siteDescription | Consumable->Site_Description | string |  |\r\n| id | Consumable->Id | integer | int64 |\r\n| currencyId | Consumable->Currency_Id | integer | int64 |\r\n| currencyCode | Consumable->Currency_Code | string |  |\r\n| currencyDescription | Consumable->Currency_Description | string |  |\r\n| description | Consumable->Description | string |  |\r\n| notes | Consumable->Notes | string |  |\r\n| unitOfMeasurementId | Consumable->UnitOfMeasurement_Id | integer | int64 |\r\n| unitOfMeasurementCode | Consumable->UnitOfMeasurement_Code | string |  |\r\n| unitOfMeasurementDescription | Consumable->UnitOfMeasurement_Description | string |  |\r\n| unitPrice | Consumable->UnitPrice | number | decimal |\r\n",
        "operationId": "BatchGetConsumable",
        "parameters": [
          {
            "name": "ids",
            "in": "path",
            "style": "simple",
            "required": true,
            "description": "A comma separated list of Consumable id's (eg. 1585760985950002,1585760985950003)",
            "schema": {
              "type": "array",
              "nullable": true,
              "items": {
                "type": "integer",
                "format": "int64"
              }
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains Consumable collection",
            "content": {
              "application/vnd.onkey.entitycollection+json": {
                "schema": {
                  "$ref": "#/components/schemas/BatchGetConsumableResourceAction"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Batch": {
      "post": {
        "tags": [
          "Consumable"
        ],
        "summary": "Create a new collection of Consumable resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Consumable->Code | string |  |\r\n| currencyId | Consumable->Currency_Id | integer | int64 |\r\n| description | Consumable->Description | string |  |\r\n| notes | Consumable->Notes | string |  |\r\n| permissionTreeId | Consumable->PermissionTree_Id | integer | int64 |\r\n| siteId | Consumable->Site_Id | integer | int64 |\r\n| unitOfMeasurementId | Consumable->UnitOfMeasurement_Id | integer | int64 |\r\n| unitPrice | Consumable->UnitPrice | number | decimal |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n| unitPrice | Min Value | >= 0|  |\r\n\r\n",
        "operationId": "BatchCreateConsumable",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "posts",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitycollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchCreateConsumableResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "201": {
            "description": "Success response - Consumable batch was successfully created"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "patch": {
        "tags": [
          "Consumable"
        ],
        "summary": "Update a collection of existing Consumable resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Consumable->Id | integer | int64 |\r\n| version | Consumable->Version | integer | int32 |\r\n| code | Consumable->Code | string |  |\r\n| currencyId | Consumable->Currency_Id | integer | int64 |\r\n| description | Consumable->Description | string |  |\r\n| notes | Consumable->Notes | string |  |\r\n| siteId | Consumable->Site_Id | integer | int64 |\r\n| unitOfMeasurementId | Consumable->UnitOfMeasurement_Id | integer | int64 |\r\n| unitPrice | Consumable->UnitPrice | number | decimal |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| unitPrice | Min Value | >= 0|  |\r\n\r\n",
        "operationId": "BatchUpdateConsumable",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "patches",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatchcollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchUpdateConsumableResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - Consumable batch was successfully updated"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "delete": {
        "tags": [
          "Consumable"
        ],
        "summary": "Delete a collection of existing Consumable resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Consumable->Id | integer | int64 |\r\n| version | Consumable->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchDeleteConsumable",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "deletes",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitydeletecollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchDeleteConsumableResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - Consumable batch was successfully deleted"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Consumables/{id}/Active": {
      "patch": {
        "tags": [
          "Consumable"
        ],
        "summary": "Change the IsActive status for an existing Consumable resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Consumable->Version | integer | int32 |\r\n| isActive | Consumable->IsActive | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| isActive | Required | True |  |\r\n| isActive | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeConsumableIsActive",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Consumable Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patch",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatch+json": {
              "schema": {
                "$ref": "#/components/schemas/ChangeConsumableIsActiveResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Consumables/{id}/PermissionTree": {
      "patch": {
        "tags": [
          "Consumable"
        ],
        "summary": "Change the PermissionTree for an existing Consumable resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Consumable->Version | integer | int32 |\r\n| permissionTreeId | Consumable->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeConsumablePermissionTree",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Consumable Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patch",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatch+json": {
              "schema": {
                "$ref": "#/components/schemas/ChangeConsumablePermissionTreeResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Batch/Active": {
      "patch": {
        "tags": [
          "Consumable"
        ],
        "summary": "Change the IsActive status for a collection of existing Consumable resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Consumable->Id | integer | int64 |\r\n| version | Consumable->Version | integer | int32 |\r\n| isActive | Consumable->IsActive | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| isActive | Required | True |  |\r\n| isActive | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeConsumableIsActive",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "patches",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatchcollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchChangeConsumableIsActiveResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Consumables/Batch/PermissionTree": {
      "patch": {
        "tags": [
          "Consumable"
        ],
        "summary": "Change the PermissionTree status for a collection of existing Consumable resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Consumable->Id | integer | int64 |\r\n| version | Consumable->Version | integer | int32 |\r\n| permissionTreeId | Consumable->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeConsumablePermissionTree",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "patches",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatchcollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchChangeConsumablePermissionTreeResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Meters/{id}": {
      "get": {
        "tags": [
          "Meter"
        ],
        "summary": "Get a Meter resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Meter->Code | string |  |\r\n| isActive | Meter->IsActive | boolean |  |\r\n| createdByUserId | Meter->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | Meter->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | Meter->CreatedByUser_FullName | string |  |\r\n| createdOn | Meter->CreatedOn | string | date-time |\r\n| modifiedByUserId | Meter->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | Meter->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | Meter->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | Meter->ModifiedOn | string | date-time |\r\n| version | Meter->Version | integer | int32 |\r\n| permissionTreeId | Meter->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | Meter->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | Meter->PermissionTree_Description | string |  |\r\n| siteId | Meter->Site_Id | integer | int64 |\r\n| siteCode | Meter->Site_Code | string |  |\r\n| siteDescription | Meter->Site_Description | string |  |\r\n| id | Meter->Id | integer | int64 |\r\n| automaticallyUpdateAverageDailyRate | Meter->AutomaticallyUpdateAverageDailyRate | boolean |  |\r\n| autoResetValue | Meter->AutoResetValue | number | decimal |\r\n| averageDailyRate | Meter->AverageDailyRate | number | decimal |\r\n| averageDailyRateCalculationQuantity | Meter->AverageDailyRateCalculationQuantity | integer | int32 |\r\n| averageDailyRateCalculationUnit | Meter->AverageDailyRateCalculationUnit | string (Allowed values: [ReadingCount, Hours, Days, Weeks, Months, Years]) | enum |\r\n| averageDailyRateMaximumValue | Meter->AverageDailyRateMaximumValue | number | decimal |\r\n| averageDailyRateVariancePercentage | Meter->AverageDailyRateVariancePercentage | number | decimal |\r\n| cumulativeReading | Meter->CumulativeReading | number | decimal |\r\n| description | Meter->Description | string |  |\r\n| isPaused | Meter->IsPaused | boolean |  |\r\n| lastReading | Meter->LastReading | number | decimal |\r\n| lastReadOn | Meter->LastReadOn | string | date-time |\r\n| lastResetOn | Meter->LastResetOn | string | date-time |\r\n| lastResetReading | Meter->LastResetReading | number | decimal |\r\n| notes | Meter->Notes | string |  |\r\n| pmrStatus | Meter->PmrStatus | string (Allowed values: [LatestMeterReadingNotValid, NotUsedByTask, MeterIsInActive, AdrIsZero, Generated, GenerationRequired]) | enum |\r\n| pmrStatusChangedOn | Meter->PmrStatusChangedOn | string | date-time |\r\n| unitOfMeasurementId | Meter->UnitOfMeasurement_Id | integer | int64 |\r\n| unitOfMeasurementCode | Meter->UnitOfMeasurement_Code | string |  |\r\n| unitOfMeasurementDescription | Meter->UnitOfMeasurement_Description | string |  |\r\n| validateAverageDailyRateMaximumValue | Meter->ValidateAverageDailyRateMaximumValue | boolean |  |\r\n| validateAverageDailyRateVariancePercentage | Meter->ValidateAverageDailyRateVariancePercentage | string (Allowed values: [SystemOption, Yes, No]) | enum |\r\n| validateReadings | Meter->ValidateReadings | boolean |  |\r\n",
        "operationId": "GetMeter",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Meter Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains Meter",
            "content": {
              "application/vnd.onkey.entity+json": {
                "schema": {
                  "$ref": "#/components/schemas/GetMeterResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "patch": {
        "tags": [
          "Meter"
        ],
        "summary": "Update an existing Meter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Meter->Version | integer | int32 |\r\n| code | Meter->Code | string |  |\r\n| description | Meter->Description | string |  |\r\n| unitOfMeasurementId | Meter->UnitOfMeasurement_Id | integer | int64 |\r\n| autoResetValue | Meter->AutoResetValue | number | decimal |\r\n| automaticallyUpdateAverageDailyRate | Meter->AutomaticallyUpdateAverageDailyRate | boolean |  |\r\n| averageDailyRateCalculationQuantity | Meter->AverageDailyRateCalculationQuantity | integer | int32 |\r\n| averageDailyRateCalculationUnit | Meter->AverageDailyRateCalculationUnit | string (Allowed values: [ReadingCount, Hours, Days, Weeks, Months, Years]) | enum |\r\n| averageDailyRate | Meter->AverageDailyRate | number | decimal |\r\n| siteId | Meter->Site_Id | integer | int64 |\r\n| validateReadings | Meter->ValidateReadings | boolean |  |\r\n| validateAverageDailyRateVariancePercentage | Meter->ValidateAverageDailyRateVariancePercentage | string (Allowed values: [SystemOption, Yes, No]) | enum |\r\n| averageDailyRateVariancePercentage | Meter->AverageDailyRateVariancePercentage | number | decimal |\r\n| validateAverageDailyRateMaximumValue | Meter->ValidateAverageDailyRateMaximumValue | boolean |  |\r\n| averageDailyRateMaximumValue | Meter->AverageDailyRateMaximumValue | number | decimal |\r\n| notes | Meter->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| unitOfMeasurementId | Nullable | False |  |\r\n| autoResetValue | Nullable | True |  |\r\n| automaticallyUpdateAverageDailyRate | Nullable | False |  |\r\n| averageDailyRate | Min Value | >= 0|  |\r\n| validateAverageDailyRateVariancePercentage | Nullable | False |  |\r\n| averageDailyRateVariancePercentage | Nullable | False | Meter->ValidateAverageDailyRateVariancePercentage eq 'Yes' |\r\n| validateAverageDailyRateMaximumValue | Nullable | False |  |\r\n| averageDailyRateMaximumValue | Nullable | False | Meter->ValidateAverageDailyRateMaximumValue eq true |\r\n\r\n",
        "operationId": "UpdateMeter",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Meter Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patch",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatch+json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateMeterResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - Meter was successfully updated"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "delete": {
        "tags": [
          "Meter"
        ],
        "summary": "Delete an existing Meter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Meter->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "DeleteMeter",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Meter Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "delete",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitydelete+json": {
              "schema": {
                "$ref": "#/components/schemas/DeleteMeterResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - Meter was successfully deleted"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Meters": {
      "get": {
        "tags": [
          "Meter"
        ],
        "summary": "Get a collection of Meter resources.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Meter->Version | integer | int32 |\r\n| id | Meter->Id | integer | int64 |\r\n| code | Meter->Code | string |  |\r\n| description | Meter->Description | string |  |\r\n| isActive | Meter->IsActive | boolean |  |\r\n| isPaused | Meter->IsPaused | boolean |  |\r\n| autoResetValue | Meter->AutoResetValue | number | decimal |\r\n| automaticallyUpdateAverageDailyRate | Meter->AutomaticallyUpdateAverageDailyRate | boolean |  |\r\n| averageDailyRateCalculationQuantity | Meter->AverageDailyRateCalculationQuantity | integer | int32 |\r\n| averageDailyRateCalculationUnit | Meter->AverageDailyRateCalculationUnit | string (Allowed values: [ReadingCount, Hours, Days, Weeks, Months, Years]) | enum |\r\n| averageDailyRate | Meter->AverageDailyRate | number | decimal |\r\n| notes | Meter->Notes | string |  |\r\n| siteId | Meter->Site_Id | integer | int64 |\r\n| siteCode | Meter->Site_Code | string |  |\r\n| siteDescription | Meter->Site_Description | string |  |\r\n| unitOfMeasurementId | Meter->UnitOfMeasurement_Id | integer | int64 |\r\n| unitOfMeasurementCode | Meter->UnitOfMeasurement_Code | string |  |\r\n| unitOfMeasurementDescription | Meter->UnitOfMeasurement_Description | string |  |\r\n| createdOn | Meter->CreatedOn | string | date-time |\r\n| modifiedOn | Meter->ModifiedOn | string | date-time |\r\n",
        "operationId": "GetMeterCollection",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable Meter collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/GetMeterCollectionResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "post": {
        "tags": [
          "Meter"
        ],
        "summary": "Create a new Meter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| autoResetValue | Meter->AutoResetValue | number | decimal |\r\n| automaticallyUpdateAverageDailyRate | Meter->AutomaticallyUpdateAverageDailyRate | boolean |  |\r\n| averageDailyRateCalculationQuantity | Meter->AverageDailyRateCalculationQuantity | integer | int32 |\r\n| averageDailyRateCalculationUnit | Meter->AverageDailyRateCalculationUnit | string (Allowed values: [ReadingCount, Hours, Days, Weeks, Months, Years]) | enum |\r\n| averageDailyRateMaximumValue | Meter->AverageDailyRateMaximumValue | number | decimal |\r\n| averageDailyRateVariancePercentage | Meter->AverageDailyRateVariancePercentage | number | decimal |\r\n| code | Meter->Code | string |  |\r\n| description | Meter->Description | string |  |\r\n| isPaused | Meter->IsPaused | boolean |  |\r\n| notes | Meter->Notes | string |  |\r\n| permissionTreeId | Meter->PermissionTree_Id | integer | int64 |\r\n| siteId | Meter->Site_Id | integer | int64 |\r\n| unitOfMeasurementId | Meter->UnitOfMeasurement_Id | integer | int64 |\r\n| validateAverageDailyRateMaximumValue | Meter->ValidateAverageDailyRateMaximumValue | boolean |  |\r\n| validateAverageDailyRateVariancePercentage | Meter->ValidateAverageDailyRateVariancePercentage | string (Allowed values: [SystemOption, Yes, No]) | enum |\r\n| validateReadings | Meter->ValidateReadings | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| autoResetValue | Nullable | True |  |\r\n| automaticallyUpdateAverageDailyRate | Nullable | False |  |\r\n| averageDailyRateMaximumValue | Nullable | False | Meter->ValidateAverageDailyRateMaximumValue eq true |\r\n| averageDailyRateVariancePercentage | Nullable | False | Meter->ValidateAverageDailyRateVariancePercentage eq 'Yes' |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| permissionTreeId | System Generated | true | If no value specified |\r\n| permissionTreeId | Nullable | False |  |\r\n| unitOfMeasurementId | Required | True |  |\r\n| unitOfMeasurementId | Nullable | False |  |\r\n| validateAverageDailyRateMaximumValue | Nullable | False |  |\r\n| validateAverageDailyRateVariancePercentage | Nullable | False |  |\r\n\r\n",
        "operationId": "CreateMeter",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "post",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entity+json": {
              "schema": {
                "$ref": "#/components/schemas/CreateMeterResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "201": {
            "$ref": "#/components/responses/created",
            "description": ""
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Meters/Lookups/LookupMeterChangePermissionTree": {
      "get": {
        "tags": [
          "Meter"
        ],
        "summary": "Lookup the permission set for changing the Meter.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupMeterChangePermissionTree",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable  collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/MeterChangePermissionTreeLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Meters/Lookups/LookupMeterInsertPermissionTree": {
      "get": {
        "tags": [
          "Meter"
        ],
        "summary": "Lookup the permission set for creating the Meter.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupMeterInsertPermissionTree",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable  collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/MeterInsertPermissionTreeLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Meters/Lookups/LookupMeterSite": {
      "get": {
        "tags": [
          "Meter"
        ],
        "summary": "Lookup the Site for the Meter.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Site->Id | integer | int64 |\r\n| code | Site->Code | string |  |\r\n| description | Site->Description | string |  |\r\n",
        "operationId": "LookupMeterSite",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable Site collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/MeterSiteLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Meters/Lookups/LookupMeterUnitOfMeasurement": {
      "get": {
        "tags": [
          "Meter"
        ],
        "summary": "Lookup the Unit Of Measurement for the Meter.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | UnitOfMeasurement->Id | integer | int64 |\r\n| code | UnitOfMeasurement->Code | string |  |\r\n| description | UnitOfMeasurement->Description | string |  |\r\n",
        "operationId": "LookupMeterUnitOfMeasurement",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable Unit Of Measurement collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/MeterUnitOfMeasurementLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Meters/Batch/{ids}": {
      "get": {
        "tags": [
          "Meter"
        ],
        "summary": "Get a collection of Meter resources for the set of id's.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Meter->Code | string |  |\r\n| isActive | Meter->IsActive | boolean |  |\r\n| createdByUserId | Meter->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | Meter->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | Meter->CreatedByUser_FullName | string |  |\r\n| createdOn | Meter->CreatedOn | string | date-time |\r\n| modifiedByUserId | Meter->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | Meter->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | Meter->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | Meter->ModifiedOn | string | date-time |\r\n| version | Meter->Version | integer | int32 |\r\n| permissionTreeId | Meter->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | Meter->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | Meter->PermissionTree_Description | string |  |\r\n| siteId | Meter->Site_Id | integer | int64 |\r\n| siteCode | Meter->Site_Code | string |  |\r\n| siteDescription | Meter->Site_Description | string |  |\r\n| id | Meter->Id | integer | int64 |\r\n| automaticallyUpdateAverageDailyRate | Meter->AutomaticallyUpdateAverageDailyRate | boolean |  |\r\n| autoResetValue | Meter->AutoResetValue | number | decimal |\r\n| averageDailyRate | Meter->AverageDailyRate | number | decimal |\r\n| averageDailyRateCalculationQuantity | Meter->AverageDailyRateCalculationQuantity | integer | int32 |\r\n| averageDailyRateCalculationUnit | Meter->AverageDailyRateCalculationUnit | string (Allowed values: [ReadingCount, Hours, Days, Weeks, Months, Years]) | enum |\r\n| averageDailyRateMaximumValue | Meter->AverageDailyRateMaximumValue | number | decimal |\r\n| averageDailyRateVariancePercentage | Meter->AverageDailyRateVariancePercentage | number | decimal |\r\n| cumulativeReading | Meter->CumulativeReading | number | decimal |\r\n| description | Meter->Description | string |  |\r\n| isPaused | Meter->IsPaused | boolean |  |\r\n| lastReading | Meter->LastReading | number | decimal |\r\n| lastReadOn | Meter->LastReadOn | string | date-time |\r\n| lastResetOn | Meter->LastResetOn | string | date-time |\r\n| lastResetReading | Meter->LastResetReading | number | decimal |\r\n| notes | Meter->Notes | string |  |\r\n| pmrStatus | Meter->PmrStatus | string (Allowed values: [LatestMeterReadingNotValid, NotUsedByTask, MeterIsInActive, AdrIsZero, Generated, GenerationRequired]) | enum |\r\n| pmrStatusChangedOn | Meter->PmrStatusChangedOn | string | date-time |\r\n| unitOfMeasurementId | Meter->UnitOfMeasurement_Id | integer | int64 |\r\n| unitOfMeasurementCode | Meter->UnitOfMeasurement_Code | string |  |\r\n| unitOfMeasurementDescription | Meter->UnitOfMeasurement_Description | string |  |\r\n| validateAverageDailyRateMaximumValue | Meter->ValidateAverageDailyRateMaximumValue | boolean |  |\r\n| validateAverageDailyRateVariancePercentage | Meter->ValidateAverageDailyRateVariancePercentage | string (Allowed values: [SystemOption, Yes, No]) | enum |\r\n| validateReadings | Meter->ValidateReadings | boolean |  |\r\n",
        "operationId": "BatchGetMeter",
        "parameters": [
          {
            "name": "ids",
            "in": "path",
            "style": "simple",
            "required": true,
            "description": "A comma separated list of Meter id's (eg. 1585760985950002,1585760985950003)",
            "schema": {
              "type": "array",
              "nullable": true,
              "items": {
                "type": "integer",
                "format": "int64"
              }
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains Meter collection",
            "content": {
              "application/vnd.onkey.entitycollection+json": {
                "schema": {
                  "$ref": "#/components/schemas/BatchGetMeterResourceAction"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Meters/Batch": {
      "post": {
        "tags": [
          "Meter"
        ],
        "summary": "Create a new collection of Meter resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| autoResetValue | Meter->AutoResetValue | number | decimal |\r\n| automaticallyUpdateAverageDailyRate | Meter->AutomaticallyUpdateAverageDailyRate | boolean |  |\r\n| averageDailyRateCalculationQuantity | Meter->AverageDailyRateCalculationQuantity | integer | int32 |\r\n| averageDailyRateCalculationUnit | Meter->AverageDailyRateCalculationUnit | string (Allowed values: [ReadingCount, Hours, Days, Weeks, Months, Years]) | enum |\r\n| averageDailyRateMaximumValue | Meter->AverageDailyRateMaximumValue | number | decimal |\r\n| averageDailyRateVariancePercentage | Meter->AverageDailyRateVariancePercentage | number | decimal |\r\n| code | Meter->Code | string |  |\r\n| description | Meter->Description | string |  |\r\n| isPaused | Meter->IsPaused | boolean |  |\r\n| notes | Meter->Notes | string |  |\r\n| permissionTreeId | Meter->PermissionTree_Id | integer | int64 |\r\n| siteId | Meter->Site_Id | integer | int64 |\r\n| unitOfMeasurementId | Meter->UnitOfMeasurement_Id | integer | int64 |\r\n| validateAverageDailyRateMaximumValue | Meter->ValidateAverageDailyRateMaximumValue | boolean |  |\r\n| validateAverageDailyRateVariancePercentage | Meter->ValidateAverageDailyRateVariancePercentage | string (Allowed values: [SystemOption, Yes, No]) | enum |\r\n| validateReadings | Meter->ValidateReadings | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| autoResetValue | Nullable | True |  |\r\n| automaticallyUpdateAverageDailyRate | Nullable | False |  |\r\n| averageDailyRateMaximumValue | Nullable | False | Meter->ValidateAverageDailyRateMaximumValue eq true |\r\n| averageDailyRateVariancePercentage | Nullable | False | Meter->ValidateAverageDailyRateVariancePercentage eq 'Yes' |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| permissionTreeId | System Generated | true | If no value specified |\r\n| permissionTreeId | Nullable | False |  |\r\n| unitOfMeasurementId | Required | True |  |\r\n| unitOfMeasurementId | Nullable | False |  |\r\n| validateAverageDailyRateMaximumValue | Nullable | False |  |\r\n| validateAverageDailyRateVariancePercentage | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchCreateMeter",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "posts",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitycollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchCreateMeterResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "201": {
            "description": "Success response - Meter batch was successfully created"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "patch": {
        "tags": [
          "Meter"
        ],
        "summary": "Update a collection of existing Meter resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Meter->Id | integer | int64 |\r\n| version | Meter->Version | integer | int32 |\r\n| code | Meter->Code | string |  |\r\n| description | Meter->Description | string |  |\r\n| unitOfMeasurementId | Meter->UnitOfMeasurement_Id | integer | int64 |\r\n| isPaused | Meter->IsPaused | boolean |  |\r\n| autoResetValue | Meter->AutoResetValue | number | decimal |\r\n| automaticallyUpdateAverageDailyRate | Meter->AutomaticallyUpdateAverageDailyRate | boolean |  |\r\n| averageDailyRateCalculationQuantity | Meter->AverageDailyRateCalculationQuantity | integer | int32 |\r\n| averageDailyRateCalculationUnit | Meter->AverageDailyRateCalculationUnit | string (Allowed values: [ReadingCount, Hours, Days, Weeks, Months, Years]) | enum |\r\n| averageDailyRate | Meter->AverageDailyRate | number | decimal |\r\n| siteId | Meter->Site_Id | integer | int64 |\r\n| validateReadings | Meter->ValidateReadings | boolean |  |\r\n| validateAverageDailyRateVariancePercentage | Meter->ValidateAverageDailyRateVariancePercentage | string (Allowed values: [SystemOption, Yes, No]) | enum |\r\n| averageDailyRateVariancePercentage | Meter->AverageDailyRateVariancePercentage | number | decimal |\r\n| validateAverageDailyRateMaximumValue | Meter->ValidateAverageDailyRateMaximumValue | boolean |  |\r\n| averageDailyRateMaximumValue | Meter->AverageDailyRateMaximumValue | number | decimal |\r\n| notes | Meter->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n| unitOfMeasurementId | Nullable | False |  |\r\n| autoResetValue | Nullable | True |  |\r\n| automaticallyUpdateAverageDailyRate | Nullable | False |  |\r\n| averageDailyRate | Min Value | >= 0|  |\r\n| validateAverageDailyRateVariancePercentage | Nullable | False |  |\r\n| averageDailyRateVariancePercentage | Nullable | False | Meter->ValidateAverageDailyRateVariancePercentage eq 'Yes' |\r\n| validateAverageDailyRateMaximumValue | Nullable | False |  |\r\n| averageDailyRateMaximumValue | Nullable | False | Meter->ValidateAverageDailyRateMaximumValue eq true |\r\n\r\n",
        "operationId": "BatchUpdateMeter",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "patches",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatchcollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchUpdateMeterResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - Meter batch was successfully updated"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "delete": {
        "tags": [
          "Meter"
        ],
        "summary": "Delete a collection of existing Meter resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Meter->Id | integer | int64 |\r\n| version | Meter->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchDeleteMeter",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "deletes",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitydeletecollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchDeleteMeterResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - Meter batch was successfully deleted"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Meters/AverageDailyRate/Batch": {
      "patch": {
        "tags": [
          "Meter"
        ],
        "summary": "Batch Change the Average Daily Rate for the Meter.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | ChangeMeterAverageDailyRate->Id | integer | int64 |\r\n| version | ChangeMeterAverageDailyRate->Version | integer | int32 |\r\n| averageDailyRate | ChangeMeterAverageDailyRate->AverageDailyRate | number | decimal |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| averageDailyRate | Required | True |  |\r\n| averageDailyRate | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeMeterAverageDailyRate",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patches",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatchcollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchChangeMeterAverageDailyRateResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Meters/Batch/{meterIds}/GeneratePredictedMeterReadings": {
      "post": {
        "tags": [
          "Meter"
        ],
        "summary": "Batch Generate Predicted Meter Readings for Meters",
        "description": "",
        "operationId": "BatchGeneratePredictedMeterReadings",
        "parameters": [
          {
            "name": "meterIds",
            "in": "path",
            "style": "simple",
            "required": true,
            "description": "A comma separated list of Meter id's (eg. 1585760985950002,1585760985950003)",
            "schema": {
              "type": "array",
              "nullable": true,
              "items": {
                "type": "integer",
                "format": "int64"
              }
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Meters/Pause/Batch": {
      "patch": {
        "tags": [
          "Meter"
        ],
        "summary": "Batch Pause the Meter.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | ResumePauseMeter->Id | integer | int64 |\r\n| version | ResumePauseMeter->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchPauseMeter",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patches",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatchcollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchPauseMeterResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Meters/Resume/Batch": {
      "patch": {
        "tags": [
          "Meter"
        ],
        "summary": "Batch Resume the Meter.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | ResumePauseMeter->Id | integer | int64 |\r\n| version | ResumePauseMeter->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchResumeMeter",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patches",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatchcollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchResumeMeterResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Meters/{id}/CalculateAverageDailyRate": {
      "patch": {
        "tags": [
          "Meter"
        ],
        "summary": "Calculate the Average Daily Rate for the Meter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| useConfiguredCalculationUnitAndQuantity | CalculateAverageDailyRate->UseConfiguredCalculationUnitAndQuantity | boolean |  |\r\n| averageDailyRateCalculationQuantity | CalculateAverageDailyRate->AverageDailyRateCalculationQuantity | integer | int32 |\r\n| averageDailyRateCalculationUnit | CalculateAverageDailyRate->AverageDailyRateCalculationUnit | string (Allowed values: [ReadingCount, Hours, Days, Weeks, Months, Years]) | enum |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| useConfiguredCalculationUnitAndQuantity | Required | True |  |\r\n| useConfiguredCalculationUnitAndQuantity | Nullable | False |  |\r\n\r\n\n### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| averageDailyRate | CalculateAverageDailyRateResult->AverageDailyRate | number | decimal |\r\n",
        "operationId": "CalculateAverageDailyRate",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Meter Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          }
        ],
        "requestBody": {
          "x-name": "patch",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatch+json": {
              "schema": {
                "$ref": "#/components/schemas/CalculateAverageDailyRateResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - body contains Meter",
            "content": {
              "application/vnd.onkey.entity+json": {
                "schema": {
                  "$ref": "#/components/schemas/CalculateAverageDailyRateResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Meters/{id}/AverageDailyRate": {
      "patch": {
        "tags": [
          "Meter"
        ],
        "summary": "Change the Average Daily Rate for the Meter.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Meter->Version | integer | int32 |\r\n| averageDailyRate | Meter->AverageDailyRate | number | decimal |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| averageDailyRate | Required | True |  |\r\n| averageDailyRate | Nullable | False |  |\r\n| averageDailyRate | Min Value | >= 0|  |\r\n\r\n",
        "operationId": "ChangeMeterAverageDailyRate",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Meter Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patch",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatch+json": {
              "schema": {
                "$ref": "#/components/schemas/ChangeMeterAverageDailyRateResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Meters/{id}/Active": {
      "patch": {
        "tags": [
          "Meter"
        ],
        "summary": "Change the IsActive status for an existing Meter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Meter->Version | integer | int32 |\r\n| isActive | Meter->IsActive | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| isActive | Required | True |  |\r\n| isActive | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeMeterIsActive",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Meter Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patch",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatch+json": {
              "schema": {
                "$ref": "#/components/schemas/ChangeMeterIsActiveResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/AOM/Meters/{id}/PermissionTree": {
      "patch": {
        "tags": [
          "Meter"
        ],
        "summary": "Change the PermissionTree for an existing Meter resource.",
[...]
